/* Copyright 2013-2015 The MathWorks, Inc. */

#include "rx_tx_buffer_sizes.h"
#include "xil_common.h"
#include "CodeInstrTgtAppSvc_CInterface.h"

/* code instrumentation buffer is statically allocated for rtiostream-based implementation */
static IOUnit_T codeInstrWriteBuffer[CODE_INSTR_TX_BUFFER_MEMUNIT_SIZE];

extern uint8_T codeInstrTgtAppSvcCreate(void) {
    return CODEINSTRTGTAPPSVC_SUCCESS;
}

extern void codeInstrTgtAppSvcDestroy(void) {
}

/* Allocation method simply returns the statically allocated buffer */
extern uint8_T codeInstrTgtAppSvcAllocBuffer(
        void** ppBuf,
        const uint16_T dataSize) {
    
    /* buffer is already statically allocated */
    *ppBuf = &codeInstrWriteBuffer[APPLICATION_ID_IDX];
    
    UNUSED_PARAMETER(dataSize);
    
    /* nothing to do as buffer is already statically allocated */
    return CODEINSTRTGTAPPSVC_SUCCESS;
}

/* return pointer to the code instrumentation buffer data */
extern IOUnit_T * codeInstrTgtAppSvcGetBufferDataPtr(
        void* const pBuf) {
    
    /* buffer is already statically allocated */
    UNUSED_PARAMETER(pBuf);
       
    return &codeInstrWriteBuffer[PAYLOAD_IDX];
}

/* send data over rtiostream */
extern uint8_T codeInstrTgtAppSvcSend(
        void* const pBuf,        
        const uint16_T dataSize) {
    
    return (uint8_T)commsEnqueueBuffer(pBuf, CODEINSTR_RTIOSTREAM_BASED_SERVICE_ID, dataSize);
}

